Add more white space or pack more data into the UI.
This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the new theming docs or check out the migration guide.
--ag-grid-size is the main control for affecting how tightly data and UI elements are packed together. It should be a value with pixel units e.g. 8px. All padding and spacing in the grid is defined as a multiple of grid-size, so increasing it will make most components larger by increasing their internal white space while leaving the size of text and icons unchanged.
.ag-theme-quartz {
--ag-grid-size: 3px; /* very compact */
}After grid size, the most common variables to change are:
--ag-row-heightand--ag-header-heightset the height of rows and headers.--ag-list-item-heightsets the height of items in lists of values, such as the rich select editor and set filter.
In the following example, classes are applied to the grid container that change compactness dynamically:
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div
style="height: 100%; display: flex; flex-direction: column; gap: 0.5rem"
>
<div style="flex: none">
<button (click)="changeSize('large')">Large</button>
<button (click)="changeSize('normal')">Normal</button>
<button (click)="changeSize('compact')">Compact</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
class="ag-theme-quartz"
[columnDefs]="columnDefs"
[theme]="theme"
[defaultColDef]="defaultColDef"
[sideBar]="sideBar"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
theme: Theme | "legacy" = "legacy";
defaultColDef: ColDef = {
editable: true,
filter: true,
};
sideBar: SideBarDef | string | string[] | boolean | null = "columns";
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
changeSize(value: string) {
const sizes = ["large", "normal", "compact"];
sizes.forEach((size) =>
document.body.classList.toggle(size, size === value),
);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.large .ag-theme-quartz {
--ag-grid-size: 10px;
--ag-list-item-height: 40px;
--ag-font-size: 32px;
}
.compact .ag-theme-quartz {
--ag-grid-size: 3px;
--ag-list-item-height: 20px;
--ag-font-size: 10px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Full list of compactness variables Copy Link
The horizontal padding of containers that contain stacked widgets, such as menus and tool panels |
The vertical padding of containers that contain stacked widgets, such as menus and tool panels |
The horizontal spacing between widgets in containers that contain horizontally stacked widgets such as the column groups header component. |
The vertical spacing between widgets in containers that contain vertically stacked widgets |
Horizontal padding for grid and header cells (vertical padding is not set explicitly, but inferred from row-height / header-height |
Height of grid rows |
Height of header rows |
Height of items in lists (example of lists are dropdown select inputs and column menu set filters) |
Height of the pagination panel at the bottom of the grid. Defaults to the header height. |
How much to indent child columns in the column tool panel relative to their parent |
How much to indent child filter items in the Set Filter List relative to their parent |
How much to indent child filter items in the Advanced Filter Builder relative to their parent |
Using CSS rules to customise compactness Copy Link
The grid contains thousands of elements. Most of them respond to --ag-grid-size but many of them don't have their own specific variables to customise size. For all elements except rows, headers and list items (see note below), you can set their height, margin or paddings using CSS rules that target a class name, e.g.
/* set the height of text inputs */
.ag-theme-quartz .ag-text-field-input {
height: 30px;
} Setting the height of rows, headers and list items Copy Link
To change the height of rows, headers and list item heights, you must use the provided CSS variables (--ag-row-height, --ag-header-height and --ag-list-item-height). The grid uses DOM virtualisation for rendering large amounts of data, and needs to know the height of virtualised elements in order to calculate their layout. It does this by measuring the values of CSS variables such as --ag-row-height.
Using CSS to set a height on a row element itself e.g. .ag-row { height: 50px; } is not supported.

Add more white space or pack more data into the UI.
This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the new theming docs or check out the migration guide.
--ag-grid-size is the main control for affecting how tightly data and UI elements are packed together. It should be a value with pixel units e.g. 8px. All padding and spacing in the grid is defined as a multiple of grid-size, so increasing it will make most components larger by increasing their internal white space while leaving the size of text and icons unchanged.
.ag-theme-quartz {
--ag-grid-size: 3px; /* very compact */
}After grid size, the most common variables to change are:
--ag-row-heightand--ag-header-heightset the height of rows and headers.--ag-list-item-heightsets the height of items in lists of values, such as the rich select editor and set filter.
In the following example, classes are applied to the grid container that change compactness dynamically:
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="height: 100%; display: flex; flex-direction: column; gap: 0.5rem">
<div style="flex: none">
<button v-on:click="changeSize('large')">Large</button>
<button v-on:click="changeSize('normal')">Normal</button>
<button v-on:click="changeSize('compact')">Compact</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
class="ag-theme-quartz"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:theme="theme"
:defaultColDef="defaultColDef"
:sideBar="sideBar"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const theme = ref<Theme | "legacy">("legacy");
const defaultColDef = ref<ColDef>({
editable: true,
filter: true,
});
const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
"columns",
);
const rowData = ref<IOlympicData[]>(null);
function changeSize(value: string) {
const sizes = ["large", "normal", "compact"];
sizes.forEach((size) =>
document.body.classList.toggle(size, size === value),
);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
theme,
defaultColDef,
sideBar,
rowData,
onGridReady,
changeSize,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.large .ag-theme-quartz {
--ag-grid-size: 10px;
--ag-list-item-height: 40px;
--ag-font-size: 32px;
}
.compact .ag-theme-quartz {
--ag-grid-size: 3px;
--ag-list-item-height: 20px;
--ag-font-size: 10px;
}
Full list of compactness variables Copy Link
The horizontal padding of containers that contain stacked widgets, such as menus and tool panels |
The vertical padding of containers that contain stacked widgets, such as menus and tool panels |
The horizontal spacing between widgets in containers that contain horizontally stacked widgets such as the column groups header component. |
The vertical spacing between widgets in containers that contain vertically stacked widgets |
Horizontal padding for grid and header cells (vertical padding is not set explicitly, but inferred from row-height / header-height |
Height of grid rows |
Height of header rows |
Height of items in lists (example of lists are dropdown select inputs and column menu set filters) |
Height of the pagination panel at the bottom of the grid. Defaults to the header height. |
How much to indent child columns in the column tool panel relative to their parent |
How much to indent child filter items in the Set Filter List relative to their parent |
How much to indent child filter items in the Advanced Filter Builder relative to their parent |
Using CSS rules to customise compactness Copy Link
The grid contains thousands of elements. Most of them respond to --ag-grid-size but many of them don't have their own specific variables to customise size. For all elements except rows, headers and list items (see note below), you can set their height, margin or paddings using CSS rules that target a class name, e.g.
/* set the height of text inputs */
.ag-theme-quartz .ag-text-field-input {
height: 30px;
} Setting the height of rows, headers and list items Copy Link
To change the height of rows, headers and list item heights, you must use the provided CSS variables (--ag-row-height, --ag-header-height and --ag-list-item-height). The grid uses DOM virtualisation for rendering large amounts of data, and needs to know the height of virtualised elements in order to calculate their layout. It does this by measuring the values of CSS variables such as --ag-row-height.
Using CSS to set a height on a row element itself e.g. .ag-row { height: 50px; } is not supported.

Add more white space or pack more data into the UI.
This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the new theming docs or check out the migration guide.
--ag-grid-size is the main control for affecting how tightly data and UI elements are packed together. It should be a value with pixel units e.g. 8px. All padding and spacing in the grid is defined as a multiple of grid-size, so increasing it will make most components larger by increasing their internal white space while leaving the size of text and icons unchanged.
.ag-theme-quartz {
--ag-grid-size: 3px; /* very compact */
}After grid size, the most common variables to change are:
--ag-row-heightand--ag-header-heightset the height of rows and headers.--ag-list-item-heightsets the height of items in lists of values, such as the rich select editor and set filter.
In the following example, classes are applied to the grid container that change compactness dynamically:
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
editable: true,
filter: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
const changeSize = useCallback((value: string) => {
const sizes = ["large", "normal", "compact"];
sizes.forEach((size) =>
document.body.classList.toggle(size, size === value),
);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div
style={{
height: "100%",
display: "flex",
flexDirection: "column",
gap: "0.5rem",
}}
>
<div style={{ flex: "none" }}>
<button onClick={() => changeSize("large")}>Large</button>
<button onClick={() => changeSize("normal")}>Normal</button>
<button onClick={() => changeSize("compact")}>Compact</button>
</div>
<div style={gridStyle} className="ag-theme-quartz">
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
theme={"legacy"}
defaultColDef={defaultColDef}
sideBar={"columns"}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.large .ag-theme-quartz {
--ag-grid-size: 10px;
--ag-list-item-height: 40px;
--ag-font-size: 32px;
}
.compact .ag-theme-quartz {
--ag-grid-size: 3px;
--ag-list-item-height: 20px;
--ag-font-size: 10px;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Full list of compactness variables Copy Link
The horizontal padding of containers that contain stacked widgets, such as menus and tool panels |
The vertical padding of containers that contain stacked widgets, such as menus and tool panels |
The horizontal spacing between widgets in containers that contain horizontally stacked widgets such as the column groups header component. |
The vertical spacing between widgets in containers that contain vertically stacked widgets |
Horizontal padding for grid and header cells (vertical padding is not set explicitly, but inferred from row-height / header-height |
Height of grid rows |
Height of header rows |
Height of items in lists (example of lists are dropdown select inputs and column menu set filters) |
Height of the pagination panel at the bottom of the grid. Defaults to the header height. |
How much to indent child columns in the column tool panel relative to their parent |
How much to indent child filter items in the Set Filter List relative to their parent |
How much to indent child filter items in the Advanced Filter Builder relative to their parent |
Using CSS rules to customise compactness Copy Link
The grid contains thousands of elements. Most of them respond to --ag-grid-size but many of them don't have their own specific variables to customise size. For all elements except rows, headers and list items (see note below), you can set their height, margin or paddings using CSS rules that target a class name, e.g.
/* set the height of text inputs */
.ag-theme-quartz .ag-text-field-input {
height: 30px;
} Setting the height of rows, headers and list items Copy Link
To change the height of rows, headers and list item heights, you must use the provided CSS variables (--ag-row-height, --ag-header-height and --ag-list-item-height). The grid uses DOM virtualisation for rendering large amounts of data, and needs to know the height of virtualised elements in order to calculate their layout. It does this by measuring the values of CSS variables such as --ag-row-height.
Using CSS to set a height on a row element itself e.g. .ag-row { height: 50px; } is not supported.